OGRE: Ogre::HardwareOcclusionQuery Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::HardwareOcclusionQuery Class Referenceabstract
Core » RenderSystem

This is a abstract class that that provides the interface for the query class for hardware occlusion. More...

`#include <OgreHardwareOcclusionQuery.h>`

Inheritance diagram for Ogre::HardwareOcclusionQuery:
[legend]

## Public Member Functions
| HardwareOcclusionQuery ()
| Object public member functions. More...
virtual | ~HardwareOcclusionQuery ()
| Object destructor. More...
virtual void | beginOcclusionQuery ()=0
| Starts the hardware occlusion query. More...
virtual void | endOcclusionQuery ()=0
| Ends the hardware occlusion test. More...
unsigned int | getLastQuerysPixelcount () const
| Let's you get the last pixel count with out doing the hardware occlusion test. More...
virtual bool | isStillOutstanding (void)=0
| Lets you know when query is done, or still be processed by the Hardware. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual bool | pullOcclusionQuery (unsigned int *NumOfFragments)=0
| Pulls the hardware occlusion query. More...

## Detailed Description

This is a abstract class that that provides the interface for the query class for hardware occlusion.

Author
  Lee Sandberg Updated on 13/8/2005 by Tuan Kuranes email: tuan..nosp@m.kura.nosp@m.nes@f.nosp@m.ree..nosp@m.fr

## Constructor & Destructor Documentation

## ◆ HardwareOcclusionQuery()

Ogre::HardwareOcclusionQuery::HardwareOcclusionQuery | ( |  | ) |

Object public member functions.

Default object constructor

## ◆ ~HardwareOcclusionQuery()

virtual Ogre::HardwareOcclusionQuery::~HardwareOcclusionQuery | ( |  | ) |
| virtual

Object destructor.

## Member Function Documentation

## ◆ beginOcclusionQuery()

virtual void Ogre::HardwareOcclusionQuery::beginOcclusionQuery | ( |  | ) |
| pure virtual

Starts the hardware occlusion query.

Remarks
  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* mOcclusionQuery; createOcclusionQuery( &mOcclusionQuery ); In the rendering loop: Draw all occluders mOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested mOcclusionQuery->endOcclusionQuery();

Results must be pulled using: UINT mNumberOfPixelsVisable; pullOcclusionQuery( &mNumberOfPixelsVisable );

Implemented in Ogre::GL3PlusHardwareOcclusionQuery, Ogre::D3D9HardwareOcclusionQuery, and Ogre::D3D11HardwareOcclusionQuery.

## ◆ endOcclusionQuery()

virtual void Ogre::HardwareOcclusionQuery::endOcclusionQuery | ( |  | ) |
| pure virtual

Ends the hardware occlusion test.

Implemented in Ogre::GL3PlusHardwareOcclusionQuery, Ogre::D3D9HardwareOcclusionQuery, and Ogre::D3D11HardwareOcclusionQuery.

## ◆ getLastQuerysPixelcount()

unsigned int Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) | const
| inline

Let's you get the last pixel count with out doing the hardware occlusion test.

Returns
  The last fragment count from the last test. Remarks This function won't give you new values, just the old value.

## ◆ isStillOutstanding()

virtual bool Ogre::HardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) |
| pure virtual

Lets you know when query is done, or still be processed by the Hardware.

Returns
  true if query isn't finished.

Implemented in Ogre::GL3PlusHardwareOcclusionQuery, Ogre::D3D9HardwareOcclusionQuery, and Ogre::D3D11HardwareOcclusionQuery.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ pullOcclusionQuery()

virtual bool Ogre::HardwareOcclusionQuery::pullOcclusionQuery | ( | unsigned int * | NumOfFragments | ) |
| pure virtual

Pulls the hardware occlusion query.

Note
  Waits until the query result is available; use isStillOutstanding if just want to test if the result is available.

Return values

  NumOfFragments | will get the resulting number of fragments.

Returns
  True if success or false if not.

Implemented in Ogre::GL3PlusHardwareOcclusionQuery, Ogre::D3D9HardwareOcclusionQuery, and Ogre::D3D11HardwareOcclusionQuery.

The documentation for this class was generated from the following file:

- OgreHardwareOcclusionQuery.h